Pull Request or Patch supplied: Resolution:

Crashes QGIS or corrupls data: Copied to github as #: 22945
Description

When exporting a model as script, vector outputs from intermediate algorithms appear as None parameter in corresponding
processing.runalg call.
Here is the exported script:

##Save Selection=name

##input=vector

#i#tselection=output vector

outputs_ QGISSELECTBYEXPRESSION_ 1=processing.runalg('qgis:selectbyexpression', input, TRUE',0,None)
outputs_ QGISSAVESELECTEDFEATURES_1=processing.runalg('qgis:saveselectedfeatures',

outputs_ QGISSELECTBYEXPRESSION_1['/RESULT'],selection)

This however causes the script to fail, because algorithm 'qgis:selectbyexpression’ does not need an output parameter in its .runalg call.
Here is the Console Message after running the script:

Error: Wrong number of parameters

ALGORITHM: Select by expression
LAYERNAME <ParameterVector>
EXPRESSION <ParameterString>
METHOD <ParameterSelection>
RESULT <OutputVector>

After having manually deleted the output parameter 'None', everything works as expected.
We experience the same issue with the following algorithms:

'ggis:selectbyattribute’
'qgis:selectbylocation’

as well as algorithms from user scripts.
QGIS 2.14.3

Python 2.7.9
Qt4.8.6

Associated revisions

Revision 421251ab - 2016-10-04 09:25 AM - Victor Olaya

[processing] dont use hidden outputs when exporting to python or displaying alg help
fixes #14998

Revision eb5fc90f - 2016-10-18 03:55 PM - Victor Olaya

[processing] dont use hidden outputs when exporting to python or displaying alg help
fixes #14998

Conflicts:

python/plugins/processing/core/GeoAlgorithm.py

History

#1 - 2016-10-04 03:09 AM - Victor Olaya
- Status changed from Open to Closed

Fixed in changeset commit:"421251abde27b2161bb18a737e1fca0f4cbd6f8a”.
